# mod-rules.mk - linux kernel module rules
#
# Copyright (c) 2009, TeamF1, Inc.
#
# modification history
# --------------------
# 01a,08Dec09,sg   written 
#
# DESCRIPTION
# This file contains linux kernel module rules
# Adapted from lib-rules.mk
#

CPU = $(TGT_CPU)

TOOL = $(TGT_TOOL)

ifeq ($(PRODUCT_BASE),)
PRODUCT_BASE=$(TEAMF1_BASE)
endif

ifeq ($(INSTALL_DIR),)
INSTALL_DIR=$(PRODUCT_BASE)/lib
endif


EXTRA_CFLAGS += -Wall -DADAPTOS -DADAPTOS_LINUX \
                -I$(TEAMF1_ADAPTOS_BASE)/h/adaptos \
                -I$(TEAMF1_ADAPTOS_BASE)/h/adaptos/$(TGT_OS)

ifeq ($(TGT_BOARD),x86PC)
EXTRA_CFLAGS += -DCONFIG_ARCH_X86PC
endif

ifeq ($(TGT_BOARD),ngfvx538)
EXTRA_CFLAGS += -DCONFIG_ARCH_NG_FVX538
endif

ifeq ($(TGT_BOARD),ngfvs338)
EXTRA_CFLAGS += -DCONFIG_ARCH_NG_FVS338
endif

ifeq ($(TGT_BOARD),ndgfv338)
EXTRA_CFLAGS += -DCONFIG_ARCH_NG_DGFV338
endif

ifeq ($(TGT_BOARD),coyote)
EXTRA_CFLAGS += -DCONFIG_ARCH_ADI_COYOTE
endif

ifeq ($(TGT_BOARD),ngfvs336g)
EXTRA_CFLAGS += -DCONFIG_ARCH_NG_FVS336G 
EXTRA_CFLAGS += -mabi=64
endif

ifeq ($(TGT_BOARD),octeon_30xx)
EXTRA_CFLAGS += -DCONFIG_ARCH_OCT_30xx
EXTRA_CFLAGS += -mabi=64
endif

ifneq ($(TGT_CPU),)
ARCH="ARCH=$(TGT_CPU)"
endif

ifneq ($(TGT_TOOL),)
CROSS="CROSS_COMPILE=$(TGT_TOOL)"
endif

# Default make rules
all:
	$(MAKE) -C $(KERNELPATH) SUBDIRS=$(shell pwd) $(CROSS) $(ARCH) modules V=1 $(EXTRA_MAKE_FLAGS)

clean:
	$(MAKE) -C $(KERNELPATH) SUBDIRS=$(shell pwd) $(CROSS) $(ARCH) clean V=1 $(EXTRA_MAKE_FLAGS)

# rule to rclean, MK_TARGET is used within subdirectories
rclean: clean
rclean: MK_TARGET = rclean
rclean: $(RCLEAN)
	$(RM) -f $(DEPEND_FILE)

